/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// Provider the model 'Provider'
type Provider string

// List of Provider
const (
	MESSAGE_PIPE Provider = "MessagePipe"
	UIB Provider = "UIB"
	TELEGRAM Provider = "Telegram"
	WEBCHAT Provider = "Webchat"
	FACEBOOK Provider = "Facebook"
	VIBER Provider = "Viber"
	TENIOS Provider = "Tenios"
	GOOGLE Provider = "Google"
	_360DIALOG Provider = "360dialog"
)

// All allowed values of Provider enum
var AllowedProviderEnumValues = []Provider{
	"MessagePipe",
	"UIB",
	"Telegram",
	"Webchat",
	"Facebook",
	"Viber",
	"Tenios",
	"Google",
	"360dialog",
}

func (v *Provider) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := Provider(value)
	for _, existing := range AllowedProviderEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid Provider", value)
}

// NewProviderFromValue returns a pointer to a valid Provider
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewProviderFromValue(v string) (*Provider, error) {
	ev := Provider(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for Provider: valid values are %v", v, AllowedProviderEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v Provider) IsValid() bool {
	for _, existing := range AllowedProviderEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to Provider value
func (v Provider) Ptr() *Provider {
	return &v
}

type NullableProvider struct {
	value *Provider
	isSet bool
}

func (v NullableProvider) Get() *Provider {
	return v.value
}

func (v *NullableProvider) Set(val *Provider) {
	v.value = val
	v.isSet = true
}

func (v NullableProvider) IsSet() bool {
	return v.isSet
}

func (v *NullableProvider) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProvider(val *Provider) *NullableProvider {
	return &NullableProvider{value: val, isSet: true}
}

func (v NullableProvider) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProvider) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

